// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"
#include "ISCW_UWidget.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UWidgetTree : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UWidgetTree() = default;
		
		virtual shared_ptr<ISCW_UWidgetTree> ToUWidgetTreePtr() = 0;
		virtual shared_ptr<const ISCW_UWidgetTree> ToUWidgetTreePtr() const = 0;

		virtual ISCW_UWidgetPtr FindWidget(const wstring& Name) const = 0;
	};

	using ISCW_UWidgetTreeConstPtr = shared_ptr<const ISCW_UWidgetTree>;
	using ISCW_UWidgetTreePtr = shared_ptr<ISCW_UWidgetTree>;
} // namespace Sourcify